@echo off
REM %1 DB Type, "DIMAUTH" or "DMNFL"
REM %2 server, e.g., "(local)"
REM %3 Dim Auth DB, e.g., "Dim Auth"
REM Dim Auth procs
if %1 == "DIMAUTH" (
REM Shared Objects
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.SPLIT.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.MAXIMUM.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.MINIMUM.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.REPLACEBLANKSWITHONE.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\proc.Get Changed Date And Last Version.sql"
REM Dimension Authority Objects
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.ETL Dimensions - Determine Dates.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.ETL Dimensions - Prepare For Initial Load.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.ETL Dimensions - Prepare Session.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.ETL Dimensions - Cleanup Session.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Static Dimensions.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Game.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Play Details.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Play Time.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Play Type.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Field Position.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Player.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Team.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.Load Dim Date.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Dimension Authority\proc.ETL Dimensions.sql"
)
REM Data Mart DB
if %1 == "DMNFL" (
REM Shared Objects
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.SPLIT.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.MAXIMUM.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.MINIMUM.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.REPLACEBLANKSWITHONE.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\fn.Insert Source DB Name In Dynamic SQL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\Shared\proc.Get Changed Date And Last Version.sql"
REM Data Mart Synonyms
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\synonyms.Create Objects - NFL.sql"
REM Common Objects
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.Delete Partitioned Views For Fact Tables.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.Create Partitioned Views For Fact Tables.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Determine Dates.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Prepare For Initial Load.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Prepare Session Id.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Cleanup Session Id.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Prepare Session.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Cleanup Session.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Register Consumer.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Synchronize Dimensions.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\proc.ETL Data Mart - Update Statistics.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\triggers.Capture Data Mart Dimension Changes.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\views.Create SSAS Common Data Mart Objects.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Normalize Date As String.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Team Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Data Source Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Date Key.sql"		
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Game Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Team Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Team Role Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Play Type Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Field Position Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Play Time Key.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM Common\fn.Get Statement To Set Play Details Key.sql"
REM Data Mart specific objects
REM Views
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\views.Create Objects SSAS - NFL.sql"
REM Functions
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\fn.Is SSAS Object Changed Since Last Load - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\fn.Get SSAS BASE DB Create Script - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\fn.Get Statement To Set Dimension Keys - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\fn.Get Statement For Fact Table - NFL.sql"
REM Procs
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.Prepare Data Mart Session - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.Pull Out Plays From NFL Savant - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.Pull Out Teams-Plays From NFL Savant - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.Load Fact Plays - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.Load Bridge Teams-Plays - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.Verify Fact Data - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.ETL Data Mart - Prepare Shared Data For Effective Date - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.ETL Data Mart - Facts - NFL.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\DM NFL\proc.Create SSAS Rule Based Roles - NFL.sql"
REM SSAS common functions and procs
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\fn.Synthesize SQL Server Connection String.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\fn.Create SSAS Instance Specific Name.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\fn.Create SSAS Partition Name Prefix.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\fn.Create SSAS Partition Name.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\fn.Create SSAS Partition Slice Attribute.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.Generate SSAS Object Schema For Cube Load XMLA Script.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.Define SSAS DB Date Based Partitions Views.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.Define SSAS DB Dimension Views.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.Define SSAS DB Single Partitions Views.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Do PostProcessing.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Do PreProcessing.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Generate Create XMLA Script.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Generate Cube Calculations XMLA Script.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Generate Delete XMLA Script.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Generate Load XMLA Script.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Generate Partitions Delete Create XMLA Script.sql"
	sqlcmd -S %2 -d %3 -i "..\SQL\SSAS Load Common\proc.ETL SSAS DB - Generate Permissions XMLA Script.sql"
)
echo on