/*
--	Copyright (c) 2007 - 2018 by Victor Shulman.
--	Written by Victor Shulman.  Not derived from licensed software.
--	
--	Permission is granted to anyone to use this software for any
--	purpose on any computer system, and to redistribute it in any way,
--	subject to the following restrictions:
--	
--	1. The author is not responsible for the consequences of use of
--		this software, no matter how awful, even if they arise
--		from defects in it.
--
--	2. The origin of this software must not be misrepresented, either
--		by explicit claim or by omission.
--	
--	3. Altered versions must be plainly marked as such, and must not
--		be misrepresented (by explicit claim or omission) as being
--		the original software.
--
--	4. This notice must not be removed or altered.
*/
-- SELECT * FROM [dwetl].[Data Mart Properties]
TRUNCATE TABLE [dwetl].[Data Mart Properties]
INSERT [dwetl].[Data Mart Properties]
(
	[Is using Partitioned Tables For Fact Tables]					,
	[Is using Partitioned Views For Fact Tables]					,
	[Is Report Unknown Keys In Facts]								,
	[Is Verify Fact Data]											,
	[Is Adjust Dim Date On Initial Load Based On Available Data]	,
	[Date Column To Consolidate Dates Changed]
)
VALUES 	( 0, 1, 1, 1, 1, 'Season Year' )

TRUNCATE TABLE [dwetl].[ETL Component Synchronization]
INSERT [dwetl].[ETL Component Synchronization] VALUES( 'FACT', NULL, NULL, NULL, NULL )

TRUNCATE TABLE [dwetl].[Data Mart Consumer Syncronization]
INSERT [dwetl].[Data Mart Consumer Syncronization]
(
	DMConsumerServerName,					
	DMConsumerDBName						
) VALUES ( 'DEFAULT', 'DEFAULT' )

TRUNCATE TABLE [dwetl].[Facts Source Table]
INSERT [dwetl].[Facts Source Table]
(
	TableServer				,
	TableDatabase			,
	TableSchema				,
	TableName				,
	IsTrackedForChanges		,
	EffectiveDateColumn		,
	IsPrimaryForMinStartDate,
	IsPrimaryForMaxEndDate	,
	ETLComponentsAffected	
)
VALUES
	( NULL, 'NFL Staging', 'nflsavant', 'play_by_play', 1, 'GameDate', 1, 1, 'FACT' )
	
	 
TRUNCATE TABLE [dwetl].[Dimension Change Tracking]
INSERT [dwetl].[Dimension Change Tracking]
(
	SSASServerName															,						
	SSASDBName																,
	SSASDimensionID															,
	[Is Synchronize Dimension From Data Mart]								,
	[ETL Components Affected]												,
	[Dimension Schema]														,
	[Dimension Name]														,
	[Dimension Key Name]													,
	[SSAS Source View Schema]												,
	[SSAS Source View Name]													,
	[SSAS Source View Key Name]												,
	[Is SSAS Date Dimension]												,
	[SSAS Source View Where Clause To Filter On SSAS Server And Database]
)	
VALUES
	( 'DEFAULT', 'DEFAULT',	'Data Source',	0,	'FACT',	'dim',			'Data Source',	'Data Source Key',	'ssasdim',	'Data Source',	'Data Source Key',	0, NULL ),	
	( 'DEFAULT', 'DEFAULT',	'Date',			0,	'FACT',	'dim',			'Date',			'Date Key',			'ssasdim',	'Date',			'Date Key',			1, NULL ),	
	( 'DEFAULT', 'DEFAULT',	'Team',			0,	'FACT',	'dim',			'Team',			'Team Key',			'ssasdim',	'Team',			'Team Key',			0, NULL ),	
	( 'DEFAULT', 'DEFAULT',	'Team Role',	0,	'FACT',	'dim',			'Team Role',	'Team Role Key',	'ssasdim',	'Team Role',	'Team Role Key',	0, NULL ),	
--	( 'DEFAULT', 'DEFAULT',	'Player',		0,	'FACT',	'dim',			'Player',		'Player Key',		'ssasdim',	'Player',		'Player Key',		0, NULL ),	
	( 'DEFAULT', 'DEFAULT',	'Game',			0,	'FACT',	'dim',			'Game',			'Game Key',			'ssasdim',	'Game',			'Game Key',			0, NULL ),	
	( 'DEFAULT', 'DEFAULT',	'Play Type',	0,	'FACT',	'dim',			'Play Type',	'Play Type Key',	'ssasdim',	'Play Type',	'Play Type Key',	0, NULL ),	
	( 'DEFAULT', 'DEFAULT',	'Play Time',	0,	'FACT',	'dim',			'Play Time',	'Play Time Key',	'ssasdim',	'Play Time',	'Play Time Key',	0, NULL ),	
	( 'DEFAULT', 'DEFAULT',	'Play Details',	0,	'FACT',	'dim',			'Play Details',	'Play Details Key',	'ssasdim',	'Play Details',	'Play Details Key', 0, NULL )
--	( 'DEFAULT', 'DEFAULT',	'Role',			0,	'',		'ssasload',	'Role',			'Role Id',			'ssasdim',	'Role',			'Role Key',			0, '[SSAS Server Name]=''<@SSASServerName>'' AND [SSAS DB Name] = ''<@SSASDatabaseName>''' )

-- SELECT * FROM [ssasload].[Measure Group]
TRUNCATE TABLE [ssasload].[Measure Group]
INSERT [ssasload].[Measure Group]
(
	[Measure Group ID]														,																								
	[Cube ID]																,
	[Data Source ID]														,
    [Is Single Partition]													,
	[Is Linked]																,
	[Is Loaded In Full]														,
	[Number Of Effectived Days In Partition]								,
	[Fact Table Schema]														,
	[Fact Table Name]														,
	[Fact Table Date Key Name]												,
	[SSAS Source View Schema]												,
	[SSAS Source View Name]													,
	[SSAS Source View Date Key Name]										,
	[SSAS Source View Where Clause To Filter On SSAS Server And Database]	
)
VALUES
( 'Plays',					'NFL Plays',	'Data Mart NFL',	1, 0, 1, 0, 'fact',	'Fact Plays',			'Play Date Key',	'ssasfact',	'Plays',				'Play Date Key',	NULL ),
( 'Bridge Teams- Plays',	'NFL Plays',	'Data Mart NFL',	1, 0, 1, 0, 'fact',	'Bridge Teams-Plays',	NULL,				'ssasfact',	'Bridge Teams-Plays',	NULL,				NULL )


TRUNCATE TABLE [ssasload].[Access Configuration]
INSERT [ssasload].[Access Configuration] ( [Access Configuration Name] )
VALUES ( 'Demo NFL' )

-- The [Source Role Name] is NULL because in this sample we don't have any source
-- system which would feed the roles (with implied rules)
TRUNCATE TABLE [ssasload].[Rule]
INSERT [ssasload].[Rule] ( [Rule Name], [SSAS Role Name], [Source Role Name] )
VALUES	( 'All Access',						'Full',							NULL ),
		( 'Restricted Attributes Access',	'Restricted Attributes Access', NULL ),
		( 'Login Based Access',				'User Access',					NULL )

TRUNCATE TABLE [ssasload].[Cube]
INSERT [ssasload].[Cube] ( [SSAS Cube Id] )
VALUES ( 'NFL Plays' )

-- Both dimensions here are role playing
TRUNCATE TABLE [ssasload].[Cube Dimension]
INSERT [ssasload].[Cube Dimension]
(
	[SSAS Cube Id]			,		
	[SSAS Dimension Id]		,
	[SSAS Dimension Name]	
)
VALUES	( 'NFL Plays', 'Team 1' , 'Offense Team' ),
		( 'NFL Plays', 'Team 1 1' , 'Defense Team' )


-- SELECT * FROM [ssasload].[Access Configuration Cube Rules And Roles]
TRUNCATE TABLE [ssasload].[Access Configuration Cube Rules And Roles]
INSERT [ssasload].[Access Configuration Cube Rules And Roles]
(
	[Access Configuration Id]	,
	[Cube Id]			,
	[Rule Id]
)
SELECT	( SELECT [Access Configuration Id] FROM [ssasload].[Access Configuration] WHERE [Access Configuration Name] = 'Demo NFL' ),
		( SELECT [Cube Id] FROM [ssasload].[Cube] WHERE	[SSAS Cube Id] = 'NFL Plays'
														AND [Access] = 'Read'
														AND [Drillthrough] ='Drillthrough'
														AND [Process] = 0 ),
		[Rule Id]
FROM [ssasload]. [Rule]
WHERE [Rule Name] IN (	'All Access', 
						'Restricted Attributes Access' ) 
						--'Login Based Access' )	-- We don't have a dimension for this case