/*
--	Copyright (c) 2007 - 2018 by Victor Shulman.
--	Written by Victor Shulman.  Not derived from licensed software.
--	
--	Permission is granted to anyone to use this software for any
--	purpose on any computer system, and to redistribute it in any way,
--	subject to the following restrictions:
--	
--	1. The author is not responsible for the consequences of use of
--		this software, no matter how awful, even if they arise
--		from defects in it.
--
--	2. The origin of this software must not be misrepresented, either
--		by explicit claim or by omission.
--	
--	3. Altered versions must be plainly marked as such, and must not
--		be misrepresented (by explicit claim or omission) as being
--		the original software.
--
--	4. This notice must not be removed or altered.
*/
USE [DW Reporting]
GO

BEGIN TRY
  ALTER ASSEMBLY [Microsoft.AnalysisServices.Adomdclient] FROM 
 'C:\Windows\assembly\GAC_MSIL\Microsoft.AnalysisServices.AdomdClient\10.0.0.0__89845dcd8080cc91\Microsoft.AnalysisServices.AdomdClient.dll'
END TRY
BEGIN CATCH
	DECLARE @ErrorMessage NVARCHAR(4000);
	DECLARE @ErrorSeverity INT;
	DECLARE @ErrorState INT;

	SELECT @ErrorMessage = ERROR_MESSAGE(),
		   @ErrorSeverity = ERROR_SEVERITY(),
		   @ErrorState = ERROR_STATE();

	--  eat error if error number is 6285, which means 
	-- "assembly is, according to MVID, identical to an assembly that is already registered"
	IF ERROR_NUMBER() = 6285 BEGIN
		PRINT 'Microsoft.AnalysisServices.AdomdClient: new version is identical to the assembly that is already registered'
	END
	ELSE BEGIN
		-- Use RAISERROR inside the CATCH block to return 
		-- error information about the original error that 
		-- caused execution to jump to the CATCH block.
		RAISERROR (@ErrorMessage, -- Message text.
				   @ErrorSeverity, -- Severity.
				   @ErrorState -- State.
				   );
	END
END CATCH
