/*
--	Copyright (c) 2007 - 2021 by Victor Shulman.
--	Written by Victor Shulman.  Not derived from licensed software.
--	
--	Permission is granted to anyone to use this software for any
--	purpose on any computer system, and to redistribute it in any way,
--	subject to the following restrictions:
--	
--	1. The author is not responsible for the consequences of use of
--		this software, no matter how awful, even if they arise
--		from defects in it.
--
--	2. The origin of this software must not be misrepresented, either
--		by explicit claim or by omission.
--	
--	3. Altered versions must be plainly marked as such, and must not
--		be misrepresented (by explicit claim or omission) as being
--		the original software.
--
--	4. This notice must not be removed or altered.
*/
using System;
using System.Collections;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using Microsoft.AnalysisServices.AdomdClient;


namespace DWJobs.ClrObjects
{
    public partial class Reporting
    {
        private class TenAttr
        {
            public SqlString Attr1;
            public SqlString Attr2;
            public SqlString Attr3;
            public SqlString Attr4;
            public SqlString Attr5;
            public SqlString Attr6;
            public SqlString Attr7;
            public SqlString Attr8;
            public SqlString Attr9;
            public SqlString Attr10;


            public TenAttr()
            {
            }
        }

        [SqlFunction(DataAccess = DataAccessKind.Read, FillRowMethodName = "SelectViaMdxTenAttrMaxFillRow", TableDefinition = @"    Attr1   NVARCHAR(500),
                                                                                                                                    Attr2   NVARCHAR(500),
                                                                                                                                    Attr3   NVARCHAR(500),
                                                                                                                                    Attr4   NVARCHAR(500),
                                                                                                                                    Attr5   NVARCHAR(500),
                                                                                                                                    Attr6   NVARCHAR(500),
                                                                                                                                    Attr7   NVARCHAR(500),
                                                                                                                                    Attr8   NVARCHAR(500),
                                                                                                                                    Attr9   NVARCHAR(500),
                                                                                                                                    Attr10  NVARCHAR(500)  ")]
        public static IEnumerable SelectViaMdxTenAttrMax([SqlFacet(MaxSize = -1)]SqlString analysisSevicesConnectionString, [SqlFacet(MaxSize = -1)]SqlString mdxQuery)
        {
            ArrayList resultCollection = new ArrayList();

            using (var conn = new AdomdConnection(analysisSevicesConnectionString.ToString()))
            {
                conn.Open();
                AdomdCommand adomdCommand = conn.CreateCommand();
                adomdCommand.CommandText = mdxQuery.ToString();

                DateTime queryStart = DateTime.Now;
                AdomdDataReader adomdReader = adomdCommand.ExecuteReader();

                int countRows = 0;

                while (adomdReader.Read())
                {
                    TenAttr tenAttr = new TenAttr();

                    int columnOrdinal = -1;
                    // ++columnOrdinal is used to increase ordinal for each value for NULL as well as non NULL values
                    tenAttr.Attr1 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr1);
                    tenAttr.Attr2 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr2);
                    tenAttr.Attr3 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr3);
                    tenAttr.Attr4 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr4);
                    tenAttr.Attr5 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr5);
                    tenAttr.Attr6 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr6);
                    tenAttr.Attr7 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr7);
                    tenAttr.Attr8 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr8);
                    tenAttr.Attr9 = (++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr9);
                    tenAttr.Attr10 =(++columnOrdinal < adomdReader.FieldCount && !adomdReader.IsDBNull(columnOrdinal) && adomdReader.GetString(columnOrdinal) != "NaN" ? adomdReader.GetString(columnOrdinal) : tenAttr.Attr10);

                    resultCollection.Add(tenAttr);
                    countRows++;
                }

                adomdReader.Close();
            }

            return resultCollection;
        }

        public static void SelectViaMdxTenAttrMaxFillRow(object tenAttrObj,
                                                                    out SqlString attr1,
                                                                    out SqlString attr2,
                                                                    out SqlString attr3,
                                                                    out SqlString attr4,
                                                                    out SqlString attr5,
                                                                    out SqlString attr6,
                                                                    out SqlString attr7,
                                                                    out SqlString attr8,
                                                                    out SqlString attr9,
                                                                    out SqlString attr10
            )
        {

            TenAttr tenAttr = (TenAttr)tenAttrObj;

            attr1 = tenAttr.Attr1;
            attr2 = tenAttr.Attr2;
            attr3 = tenAttr.Attr3;
            attr4 = tenAttr.Attr4;
            attr5 = tenAttr.Attr5;
            attr6 = tenAttr.Attr6;
            attr7 = tenAttr.Attr7;
            attr8 = tenAttr.Attr8;
            attr9 = tenAttr.Attr9;
            attr10 = tenAttr.Attr10;
        }
    }
}