﻿/*
--	Copyright (c) 2007 - 2021 by Victor Shulman.
--	Written by Victor Shulman.  Not derived from licensed software.
--	
--	Permission is granted to anyone to use this software for any
--	purpose on any computer system, and to redistribute it in any way,
--	subject to the following restrictions:
--	
--	1. The author is not responsible for the consequences of use of
--		this software, no matter how awful, even if they arise
--		from defects in it.
--
--	2. The origin of this software must not be misrepresented, either
--		by explicit claim or by omission.
--	
--	3. Altered versions must be plainly marked as such, and must not
--		be misrepresented (by explicit claim or omission) as being
--		the original software.
--
--	4. This notice must not be removed or altered.
*/

namespace DWJobs.TabularSetsComparer.InputConfigXml
{
    public class CompareScenario
    {
        public enum CompareScenarioType
        {
            SqlResultSetsCompare = 0,
            MdxResultsSetsCompare = 1,
        };

        /// <summary>
        /// action can be skipped of not Actlve
        /// </summary>
        public bool Active
        {
            get;
            set;
        }

        public string DatabaseName
        {
            get;
            set;
        }

        public string ScenarioName
        {
            get;
            set;
        }

        public string InputFolderPath
        {
            get;
            set;
        }

        /// <summary>
        /// Columns and corresponding types.
        /// Columns must be enclosed in Braces.
        /// Allowed Types are VARCHAR(..), DATE and FLOAT
        /// </sunmary>
        public string ResultSetColumnsAndTypes
        {
            get;
            set;
        }

        /// <summary>
        /// Key cofumns to use as keys to compare.
        /// </summary>
        public string UniqueKeyColumns
        {
            get;
            set;
        }

        /// <summary>
        /// Non  key colum ns to exclude from compare
        /// </summary>
        /// 
        public string ExcludeFromCompareColumns
        {
            get;
            set;
        }

        public string StartDate
        {
            get;
            set;
        }

        public string EndDate
        {
            get;
            set;
        }

        public string AliasLeft
        {
            get;
            set;
        }

        public string AliasRight
        {
            get;
            set;
        }

        public string CompareResultsFolderPath
        {
            get;
            set;
        }

        public double FloatCompareThreshold
        {
            get;
            set;
        }

        public CompareScenarioType ScenarioType
        {
            get;
            set;
        }

        public string SSASConnectionStringLeft
        {
            get;
            set;
        }

        public string SSASConnectionStringRight
        {
            get;
            set;
        }

        public string QueryLeft
        {
            get;
            set;
        }

        public string QueryRight
        {
            get;
            set;
        }
    }
}
