﻿/*
--	Copyright (c) 2007 - 2021 by Victor Shulman.
--	Written by Victor Shulman.  Not derived from licensed software.
--	
--	Permission is granted to anyone to use this software for any
--	purpose on any computer system, and to redistribute it in any way,
--	subject to the following restrictions:
--	
--	1. The author is not responsible for the consequences of use of
--		this software, no matter how awful, even if they arise
--		from defects in it.
--
--	2. The origin of this software must not be misrepresented, either
--		by explicit claim or by omission.
--	
--	3. Altered versions must be plainly marked as such, and must not
--		be misrepresented (by explicit claim or omission) as being
--		the original software.
--
--	4. This notice must not be removed or altered.
*/
using System;

using DWJobs.Common.AppEnvironment;
using DWJobs.TabularSetsComparer.InputConfigXml;

namespace DWJobs.TabularSetsComparer
{
    public static class TabularSetsComparerFactory
    {
        public static ITabularSetsComparer Create(CompareScenario compareScenario, CompareDatabase db)
        {
            if (compareScenario.ScenarioType == CompareScenario.CompareScenarioType.MdxResultsSetsCompare)
                return new MdxTabularSetsComparer(compareScenario, db, AppConfiguration.Log);
            else if (compareScenario.ScenarioType == CompareScenario.CompareScenarioType.SqlResultSetsCompare )
                return new SqlTabularSetsComparer(compareScenario, db, AppConfiguration.Log);

            throw new InvalidOperationException("Unsupported data source: " + compareScenario.ScenarioType.ToString());
        }

    }
}
