/*
--	Copyright (c) 2007 - 2018 by Victor Shulman.
--	Written by Victor Shulman.  Not derived from licensed software.
--	
--	Permission is granted to anyone to use this software for any
--	purpose on any computer system, and to redistribute it in any way,
--	subject to the following restrictions:
--	
--	1. The author is not responsible for the consequences of use of
--		this software, no matter how awful, even if they arise
--		from defects in it.
--
--	2. The origin of this software must not be misrepresented, either
--		by explicit claim or by omission.
--	
--	3. Altered versions must be plainly marked as such, and must not
--		be misrepresented (by explicit claim or omission) as being
--		the original software.
--
--	4. This notice must not be removed or altered.
*/
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[ssasload].[Get SSAS BASE DB Create Script - NFL]'))
BEGIN
DROP FUNCTION [ssasload].[Get SSAS BASE DB Create Script - NFL]
PRINT 'DROPED FUNCTION [ssasload].[Get SSAS BASE DB Create Script - NFL]'
END
GO

-- =============================================
-- Author:		Victor Shulman
-- =============================================

CREATE FUNCTION [ssasload].[Get SSAS BASE DB Create Script - NFL] ( )
RETURNS VARCHAR(MAX)
AS
BEGIN
RETURN '
<Create xmlns="http://schemas.microsoft.com/analysisservices/2003/engine">
    <ObjectDefinition>
        <Database xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ddl2="http://schemas.microsoft.com/analysisservices/2003/engine/2" xmlns:ddl2_2="http://schemas.microsoft.com/analysisservices/2003/engine/2/2" xmlns:ddl100_100="http://schemas.microsoft.com/analysisservices/2008/engine/100/100" xmlns:ddl200="http://schemas.microsoft.com/analysisservices/2010/engine/200" xmlns:ddl200_200="http://schemas.microsoft.com/analysisservices/2010/engine/200/200">
            <ID>Base NFL DW</ID>
            <Name>Base NFL DW</Name>
            <Language>1033</Language>
            <Collation>Latin1_General_CI_AS</Collation>
            <DataSourceImpersonationInfo>
                <ImpersonationMode>Default</ImpersonationMode>
            </DataSourceImpersonationInfo>
            <Dimensions>
                <Dimension>
                    <ID>Date</ID>
                    <Name>Date</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1621" scrolltop="-2042" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="12256" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Date" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3683" height="4466" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000630e000072110000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Date" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1621</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-2042</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ARDiagramLayout</Name>
                            <Value>
                                <DiagramLayout ZoomPercent="100" ViewPortX="0" ViewPortY="0" xmlns="">
                                    <Shapes NodeWidth="172">
                                        <Shape Id="Date Key" Expanded="false">
                                            <Attributes>
                                                <Attribute Id="Date Key" />
                                            </Attributes>
                                            <Position x="20" y="20" />
                                        </Shape>
                                        <Shape Id="Season Description" Expanded="false">
                                            <Attributes>
                                                <Attribute Id="Season Description" />
                                            </Attributes>
                                            <Position x="240" y="20" />
                                        </Shape>
                                        <Shape Id="Month Name" Expanded="false">
                                            <Attributes>
                                                <Attribute Id="Month Name" />
                                            </Attributes>
                                            <Position x="240" y="69" />
                                        </Shape>
                                        <Shape Id="Quarter" Expanded="false">
                                            <Attributes>
                                                <Attribute Id="Quarter" />
                                            </Attributes>
                                            <Position x="460" y="69" />
                                        </Shape>
                                        <Shape Id="Year" Expanded="false">
                                            <Attributes>
                                                <Attribute Id="Year" />
                                            </Attributes>
                                            <Position x="680" y="69" />
                                        </Shape>
                                    </Shapes>
                                </DiagramLayout>
                            </Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <Type>Time</Type>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Date Key</ID>
                            <Name>Date</Name>
                            <Type>Date</Type>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>Integer</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Date</TableID>
                                        <ColumnID>Date_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>25</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Date</TableID>
                                    <ColumnID>Date_x0020_Desc</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Month Name</AttributeID>
                                    <RelationshipType>Rigid</RelationshipType>
                                    <Name>Month</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Season Description</AttributeID>
                                    <RelationshipType>Rigid</RelationshipType>
                                    <Name>Season Description</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Month Name</ID>
                            <Name>Month</Name>
                            <Type>Months</Type>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>Integer</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Date</TableID>
                                        <ColumnID>Z_x0020_Month_x0020_Name_x0020_Sort</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>9</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Date</TableID>
                                    <ColumnID>Month_x0020_Name</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Quarter</AttributeID>
                                    <RelationshipType>Rigid</RelationshipType>
                                    <Name>Quarter</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Year</ID>
                            <Name>Year</Name>
                            <Type>Years</Type>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>SmallInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Date</TableID>
                                        <ColumnID>Year</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Date</TableID>
                                    <ColumnID>Year</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Quarter</ID>
                            <Name>Quarter</Name>
                            <Type>Quarters</Type>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>SmallInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Date</TableID>
                                        <ColumnID>Quarter</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>8</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Date</TableID>
                                    <ColumnID>Quarter_x0020_Desc</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Year</AttributeID>
                                    <RelationshipType>Rigid</RelationshipType>
                                    <Name>Year</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Season Description</ID>
                            <Name>Season Description</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Date</TableID>
                                        <ColumnID>Season_x0020_Description</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Date</TableID>
                                    <ColumnID>Season_x0020_Description</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                    </Attributes>
                    <Hierarchies>
                        <Hierarchy>
                            <ID>Hierarchy</ID>
                            <Name>Game Date</Name>
                            <Levels>
                                <Level>
                                    <ID>Date</ID>
                                    <Name>Date</Name>
                                    <SourceAttributeID>Date Key</SourceAttributeID>
                                </Level>
                            </Levels>
                        </Hierarchy>
                        <Hierarchy>
                            <ID>Hierarchy 1</ID>
                            <Name>Game YQMD</Name>
                            <Levels>
                                <Level>
                                    <ID>Year</ID>
                                    <Name>Year</Name>
                                    <SourceAttributeID>Year</SourceAttributeID>
                                </Level>
                                <Level>
                                    <ID>Quarter</ID>
                                    <Name>Quarter</Name>
                                    <SourceAttributeID>Quarter</SourceAttributeID>
                                </Level>
                                <Level>
                                    <ID>Month</ID>
                                    <Name>Month</Name>
                                    <SourceAttributeID>Month Name</SourceAttributeID>
                                </Level>
                                <Level>
                                    <ID>Date</ID>
                                    <Name>Date</Name>
                                    <SourceAttributeID>Date Key</SourceAttributeID>
                                </Level>
                            </Levels>
                        </Hierarchy>
                        <Hierarchy>
                            <ID>Hierarchy 2</ID>
                            <Name>Season</Name>
                            <Levels>
                                <Level>
                                    <ID>Season Description</ID>
                                    <Name>Season</Name>
                                    <SourceAttributeID>Season Description</SourceAttributeID>
                                </Level>
                            </Levels>
                        </Hierarchy>
                    </Hierarchies>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Data Source</ID>
                    <Name>Data Source</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1038" scrolltop="-1821" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="6308" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Data Source" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="4149" height="2667" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000351000006b0a0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Data Source" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1038</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-1821</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Data Source Key</ID>
                            <Name>Data Source Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>UnsignedTinyInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Data_x0020_Source</TableID>
                                        <ColumnID>Data_x0020_Source_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Data_x0020_Source</TableID>
                                    <ColumnID>Data_x0020_Source_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Data Source Name</AttributeID>
                                    <Name>Data Source Name</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Data Source Name</ID>
                            <Name>Data Source Name</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>50</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Data_x0020_Source</TableID>
                                        <ColumnID>Data_x0020_Source_x0020_Name</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>50</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Data_x0020_Source</TableID>
                                    <ColumnID>Data_x0020_Source_x0020_Name</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Team Role</ID>
                    <Name>Team Role</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1546" scrolltop="-2360" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="6308" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Team Role" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3133" height="1588" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="000800003d0c000034060000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Team Role" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1546</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-2360</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Team Role Key</ID>
                            <Name>Team Role Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>UnsignedTinyInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team_x0020_Role</TableID>
                                        <ColumnID>Team_x0020_Role_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team_x0020_Role</TableID>
                                    <ColumnID>Team_x0020_Role_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Team Role</AttributeID>
                                    <Name>Team Role</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Team Role</ID>
                            <Name>Team Role</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>50</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team_x0020_Role</TableID>
                                        <ColumnID>Team_x0020_Role</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>50</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team_x0020_Role</TableID>
                                    <ColumnID>Team_x0020_Role</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Play Type</ID>
                    <Name>Play Type</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1609" scrolltop="-1821" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="6308" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Type" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3006" height="2667" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000be0b00006b0a0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Play Type" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1609</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-1821</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Play Type Key</ID>
                            <Name>Play Type Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>SmallInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                        <ColumnID>Play_x0020_Type_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Type</TableID>
                                    <ColumnID>Play_x0020_Type_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Formation</AttributeID>
                                    <Name>Formation</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Play Type</AttributeID>
                                    <Name>Play Type</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Pass Type</AttributeID>
                                    <Name>Pass Type</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Penalty Type</AttributeID>
                                    <Name>Penalty Type</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Formation</ID>
                            <Name>Formation</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                        <ColumnID>Formation</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Type</TableID>
                                    <ColumnID>Formation</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Play Type</ID>
                            <Name>Play Type</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                        <ColumnID>Play_x0020_Type</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Type</TableID>
                                    <ColumnID>Play_x0020_Type</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Pass Type</ID>
                            <Name>Pass Type</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                        <ColumnID>Pass_x0020_Type</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Type</TableID>
                                    <ColumnID>Pass_x0020_Type</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Penalty Type</ID>
                            <Name>Penalty Type</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                        <ColumnID>Penalty_x0020_Type</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Type</TableID>
                                    <ColumnID>Penalty_x0020_Type</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Play Time</ID>
                    <Name>Play Time</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1612" scrolltop="-2001" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="6308" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Time" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3000" height="2307" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000b80b000003090000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Play Time" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1612</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-2001</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Play Time Key</ID>
                            <Name>Play Time Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>Integer</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                        <ColumnID>Play_x0020_Time_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Time</TableID>
                                    <ColumnID>Play_x0020_Time_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Quarter</AttributeID>
                                    <Name>Quarter</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Minute</AttributeID>
                                    <Name>Minute</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Second</AttributeID>
                                    <Name>Second</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Quarter</ID>
                            <Name>Quarter</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                        <ColumnID>Quarter</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Time</TableID>
                                    <ColumnID>Quarter</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Minute</ID>
                            <Name>Minute</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                        <ColumnID>Minute</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Time</TableID>
                                    <ColumnID>Minute</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Second</ID>
                            <Name>Second</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                        <ColumnID>Second</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Time</TableID>
                                    <ColumnID>Second</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Team</ID>
                    <Name>Team</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1197" scrolltop="-1281" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="12256" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Team" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3831" height="3747" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000f70e0000a30e0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Team" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1197</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-1281</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Team Key</ID>
                            <Name>Team Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>SmallInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team</TableID>
                                        <ColumnID>Team_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team</TableID>
                                    <ColumnID>Team_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Team Alias</AttributeID>
                                    <Name>Team Alias</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Offense Team</AttributeID>
                                    <Name>Offense Team</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Defense Team</AttributeID>
                                    <Name>Defense Team</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Penalty Team</AttributeID>
                                    <Name>Penalty Team</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Timeout Team</AttributeID>
                                    <Name>Timeout Team</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Team Alias</ID>
                            <Name>Team Alias</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>250</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team</TableID>
                                        <ColumnID>Team_x0020_Alias</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>250</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team</TableID>
                                    <ColumnID>Team_x0020_Alias</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Offense Team</ID>
                            <Name>Offense Team</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>250</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team</TableID>
                                        <ColumnID>Offense_x0020_Team</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>250</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team</TableID>
                                    <ColumnID>Offense_x0020_Team</ColumnID>
                                </Source>
                            </NameColumn>
                        </Attribute>
                        <Attribute>
                            <ID>Defense Team</ID>
                            <Name>Defense Team</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>250</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team</TableID>
                                        <ColumnID>Defense_x0020_Team</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>250</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team</TableID>
                                    <ColumnID>Defense_x0020_Team</ColumnID>
                                </Source>
                            </NameColumn>
                        </Attribute>
                        <Attribute>
                            <ID>Penalty Team</ID>
                            <Name>Penalty Team</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>250</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team</TableID>
                                        <ColumnID>Penalty_x0020_Team</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>250</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team</TableID>
                                    <ColumnID>Penalty_x0020_Team</ColumnID>
                                </Source>
                            </NameColumn>
                        </Attribute>
                        <Attribute>
                            <ID>Timeout Team</ID>
                            <Name>Timeout Team</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>250</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Team</TableID>
                                        <ColumnID>Timeout_x0020_Team</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>250</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Team</TableID>
                                    <ColumnID>Timeout_x0020_Team</ColumnID>
                                </Source>
                            </NameColumn>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Game</ID>
                    <Name>Game</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1612" scrolltop="-2181" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="12256" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Game" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3000" height="1947" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000b80b00009b070000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Game" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1612</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-2181</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Game Key</ID>
                            <Name>Game Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>Integer</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Game</TableID>
                                        <ColumnID>Game_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Game</TableID>
                                    <ColumnID>Game_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Game Teams</AttributeID>
                                    <Name>Game Teams</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Game Id</AttributeID>
                                    <Name>Game Id</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Game Teams</ID>
                            <Name>Game Teams</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Game</TableID>
                                        <ColumnID>Game_x0020_Teams</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Game</TableID>
                                    <ColumnID>Game_x0020_Teams</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Game Id</ID>
                            <Name>Game Id</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Game</TableID>
                                        <ColumnID>Game_x0020_Id</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Game</TableID>
                                    <ColumnID>Game_x0020_Id</ColumnID>
                                </Source>
                            </NameColumn>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Play Details</ID>
                    <Name>Play Details</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-212" scrolltop="-654" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="6308" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Details" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="5800" height="5000" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000a816000088130000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Play Details" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-212</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-654</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Play Details Key</ID>
                            <Name>Play Details Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>SmallInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Play_x0020_Details_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Play_x0020_Details_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Is Rush</AttributeID>
                                    <Name>Is Rush</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Pass</AttributeID>
                                    <Name>Is Pass</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Incomplete</AttributeID>
                                    <Name>Is Incomplete</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Touchdown</AttributeID>
                                    <Name>Is Touchdown</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Sack</AttributeID>
                                    <Name>Is Sack</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Challenge</AttributeID>
                                    <Name>Is Challenge</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Challenge Reversed</AttributeID>
                                    <Name>Is Challenge Reversed</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Measurement</AttributeID>
                                    <Name>Is Measurement</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Interception</AttributeID>
                                    <Name>Is Interception</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Fumble</AttributeID>
                                    <Name>Is Fumble</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Penalty</AttributeID>
                                    <Name>Is Penalty</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Two Point Conversion</AttributeID>
                                    <Name>Is Two Point Conversion</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Two Point Conversion Successful</AttributeID>
                                    <Name>Is Two Point Conversion Successful</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is Penalty Accepted</AttributeID>
                                    <Name>Is Penalty Accepted</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Is No Play</AttributeID>
                                    <Name>Is No Play</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Is Rush</ID>
                            <Name>Is Rush</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Rush</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Rush</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Pass</ID>
                            <Name>Is Pass</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Pass</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Pass</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Incomplete</ID>
                            <Name>Is Incomplete</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Incomplete</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Incomplete</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Touchdown</ID>
                            <Name>Is Touchdown</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Touchdown</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Touchdown</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Sack</ID>
                            <Name>Is Sack</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Sack</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Sack</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Challenge</ID>
                            <Name>Is Challenge</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Challenge</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Challenge</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Challenge Reversed</ID>
                            <Name>Is Challenge Reversed</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Challenge_x0020_Reversed</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Challenge_x0020_Reversed</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Measurement</ID>
                            <Name>Is Measurement</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Measurement</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Measurement</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Interception</ID>
                            <Name>Is Interception</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Interception</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Interception</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Fumble</ID>
                            <Name>Is Fumble</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Fumble</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Fumble</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Penalty</ID>
                            <Name>Is Penalty</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Penalty</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Penalty</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Two Point Conversion</ID>
                            <Name>Is Two Point Conversion</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Two_x0020_Point_x0020_Conversion</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Two_x0020_Point_x0020_Conversion</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Two Point Conversion Successful</ID>
                            <Name>Is Two Point Conversion Successful</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Two_x0020_Point_x0020_Conversion_x0020_Successful</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Two_x0020_Point_x0020_Conversion_x0020_Successful</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is Penalty Accepted</ID>
                            <Name>Is Penalty Accepted</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_Penalty_x0020_Accepted</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_Penalty_x0020_Accepted</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Is No Play</ID>
                            <Name>Is No Play</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>10</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                        <ColumnID>Is_x0020_No_x0020_Play</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>10</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Play_x0020_Details</TableID>
                                    <ColumnID>Is_x0020_No_x0020_Play</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
                <Dimension>
                    <ID>Field Position</ID>
                    <Name>Field Position</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="2" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="-1292" scrolltop="-1641" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="6265" y="6308" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="0" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Field Position" left="20" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3641" height="3027" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000390e0000d30b0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Field Position" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>-1292</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>-1641</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>20</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Source xsi:type="DataSourceViewBinding">
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ErrorConfiguration>
                        <KeyNotFound>ReportAndStop</KeyNotFound>
                        <KeyDuplicate>ReportAndStop</KeyDuplicate>
                        <NullKeyNotAllowed>ReportAndStop</NullKeyNotAllowed>
                    </ErrorConfiguration>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <UnknownMemberName>Unknown</UnknownMemberName>
                    <Attributes>
                        <Attribute>
                            <ID>Field Position Key</ID>
                            <Name>Field Position Key</Name>
                            <Usage>Key</Usage>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>SmallInt</DataType>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                        <ColumnID>Field_x0020_Position_x0020_Key</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Field_x0020_Position</TableID>
                                    <ColumnID>Field_x0020_Position_x0020_Key</ColumnID>
                                </Source>
                            </NameColumn>
                            <AttributeRelationships>
                                <AttributeRelationship>
                                    <AttributeID>Down</AttributeID>
                                    <Name>Down</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Yard Line</AttributeID>
                                    <Name>Yard Line</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Rush Direction</AttributeID>
                                    <Name>Rush Direction</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Yard Line Fixed</AttributeID>
                                    <Name>Yard Line Fixed</Name>
                                </AttributeRelationship>
                                <AttributeRelationship>
                                    <AttributeID>Yard Line Direction</AttributeID>
                                    <Name>Yard Line Direction</Name>
                                </AttributeRelationship>
                            </AttributeRelationships>
                            <OrderBy>Key</OrderBy>
                            <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                        </Attribute>
                        <Attribute>
                            <ID>Down</ID>
                            <Name>Down</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>20</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                        <ColumnID>Down</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>20</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Field_x0020_Position</TableID>
                                    <ColumnID>Down</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Yard Line</ID>
                            <Name>Yard Line</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>20</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                        <ColumnID>Yard_x0020_Line</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>20</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Field_x0020_Position</TableID>
                                    <ColumnID>Yard_x0020_Line</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Rush Direction</ID>
                            <Name>Rush Direction</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                        <ColumnID>Rush_x0020_Direction</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Field_x0020_Position</TableID>
                                    <ColumnID>Rush_x0020_Direction</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Yard Line Fixed</ID>
                            <Name>Yard Line Fixed</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>20</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                        <ColumnID>Yard_x0020_Line_x0020_Fixed</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>20</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Field_x0020_Position</TableID>
                                    <ColumnID>Yard_x0020_Line_x0020_Fixed</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                        <Attribute>
                            <ID>Yard Line Direction</ID>
                            <Name>Yard Line Direction</Name>
                            <KeyColumns>
                                <KeyColumn>
                                    <DataType>WChar</DataType>
                                    <DataSize>200</DataSize>
                                    <Source xsi:type="ColumnBinding">
                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                        <ColumnID>Yard_x0020_Line_x0020_Direction</ColumnID>
                                    </Source>
                                </KeyColumn>
                            </KeyColumns>
                            <NameColumn>
                                <DataType>WChar</DataType>
                                <DataSize>200</DataSize>
                                <Source xsi:type="ColumnBinding">
                                    <TableID>ssasdim_Field_x0020_Position</TableID>
                                    <ColumnID>Yard_x0020_Line_x0020_Direction</ColumnID>
                                </Source>
                            </NameColumn>
                            <OrderBy>Key</OrderBy>
                        </Attribute>
                    </Attributes>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Dimension>
            </Dimensions>
            <Cubes>
                <Cube>
                    <ID>NFL Plays</ID>
                    <Name>NFL Plays</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramLayout</Name>
                            <Value>
                                <dds xmlns="">
                                    <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="12" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="0" scrolltop="0" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="100" x="15155" y="12256" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="1" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                        <font>
                                            <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                        </font>
                                        <mouseicon>
                                            <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                        </mouseicon>
                                    </diagram>
                                    <layoutmanager>
                                        <ddsxmlobj />
                                    </layoutmanager>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Plays" left="0" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3281" height="4826" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000d10c0000da120000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasfact_Plays" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Date" left="7240" top="4466" logicalid="2" controlid="2" masterid="0" hint1="0" hint2="0" width="3620" height="4466" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000240e000072110000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Date" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Field Position" left="3492" top="7565" logicalid="3" controlid="3" masterid="0" hint1="0" hint2="0" width="3493" height="3027" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000a50d0000d30b0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Field Position" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Game" left="4500" top="1946" logicalid="4" controlid="4" masterid="0" hint1="0" hint2="0" width="3000" height="1947" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000b80b00009b070000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Game" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Details" left="11260" top="0" logicalid="5" controlid="5" masterid="0" hint1="0" hint2="0" width="5630" height="5000" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000fe15000088130000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Play Details" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Time" left="12000" top="5765" logicalid="6" controlid="6" masterid="0" hint1="0" hint2="0" width="3000" height="2307" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000b80b000003090000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Play Time" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Type" left="0" top="6665" logicalid="7" controlid="7" masterid="0" hint1="0" hint2="0" width="3000" height="2667" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000b80b00006b0a0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Play Type" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Team" left="0" top="0" logicalid="8" controlid="8" masterid="0" hint1="0" hint2="0" width="3641" height="3747" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000390e0000a30e0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Team" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Data Source" left="0" top="0" logicalid="9" controlid="9" masterid="0" hint1="0" hint2="0" width="4085" height="2667" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000f50f00006b0a0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Data Source" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Bridge Teams-Plays" left="0" top="0" logicalid="10" controlid="10" masterid="0" hint1="0" hint2="0" width="3281" height="3387" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000d10c00003b0d0000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasfact_Bridge Teams-Plays" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                    <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Team Role" left="7515" top="2382" logicalid="11" controlid="11" masterid="0" hint1="0" hint2="0" width="3006" height="1588" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                        <control>
                                            <ddsxmlobjectstreaminitwrapper binary="00080000be0b000034060000" />
                                        </control>
                                        <layoutobject>
                                            <ddsxmlobj>
                                                <property name="LogicalObject" value="ssasdim_Team Role" vartype="8" />
                                            </ddsxmlobj>
                                        </layoutobject>
                                        <shape groupshapeid="0" groupnode="0" />
                                    </ddscontrol>
                                </dds>
                            </Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowRelationshipNames</Name>
                            <Value>false</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:UseDiagramDefaultLayout</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortLeft</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramViewPortTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingLeft</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramBoundingTop</Name>
                            <Value>0</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:DiagramZoom</Name>
                            <Value>100</Value>
                        </Annotation>
                    </Annotations>
                    <Language>1033</Language>
                    <Collation>Latin1_General_CI_AS</Collation>
                    <Dimensions>
                        <Dimension>
                            <ID>Date</ID>
                            <Name>Date</Name>
                            <DimensionID>Date</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Date Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Month Name</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Year</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Quarter</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Season Description</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                            </Attributes>
                            <Hierarchies>
                                <Hierarchy>
                                    <HierarchyID>Hierarchy</HierarchyID>
                                </Hierarchy>
                                <Hierarchy>
                                    <HierarchyID>Hierarchy 1</HierarchyID>
                                </Hierarchy>
                                <Hierarchy>
                                    <HierarchyID>Hierarchy 2</HierarchyID>
                                </Hierarchy>
                            </Hierarchies>
                        </Dimension>
                        <Dimension>
                            <ID>Field Position</ID>
                            <Name>Field Position</Name>
                            <DimensionID>Field Position</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Field Position Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Down</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Yard Line</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Rush Direction</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Yard Line Fixed</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Yard Line Direction</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Game</ID>
                            <Name>Game</Name>
                            <DimensionID>Game</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Game Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Game Teams</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Game Id</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Play Details</ID>
                            <Name>Play Details</Name>
                            <DimensionID>Play Details</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Play Details Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Rush</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Pass</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Incomplete</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Touchdown</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Sack</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Challenge</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Challenge Reversed</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Measurement</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Interception</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Fumble</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Penalty</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Two Point Conversion</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Two Point Conversion Successful</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is Penalty Accepted</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Is No Play</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Play Time</ID>
                            <Name>Play Time</Name>
                            <DimensionID>Play Time</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Play Time Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Quarter</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Minute</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Second</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Play Type</ID>
                            <Name>Play Type</Name>
                            <DimensionID>Play Type</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Play Type Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Formation</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Play Type</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Pass Type</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Penalty Type</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Team</ID>
                            <Name>Team</Name>
                            <DimensionID>Team</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Team Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Team Alias</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Offense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Defense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Penalty Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Timeout Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Data Source</ID>
                            <Name>Data Source</Name>
                            <DimensionID>Data Source</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Data Source Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Data Source Name</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Team Role</ID>
                            <Name>Team Role</Name>
                            <DimensionID>Team Role</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Team Role Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Team Role</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Team 1</ID>
                            <Name>Offense Team</Name>
                            <DimensionID>Team</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Team Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Team Alias</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Offense Team</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Defense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Penalty Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Timeout Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Team 1 1</ID>
                            <Name>Defense Team</Name>
                            <DimensionID>Team</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Team Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Team Alias</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Offense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Defense Team</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Penalty Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Timeout Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Team 1 2</ID>
                            <Name>Penalty Team</Name>
                            <DimensionID>Team</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Team Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Team Alias</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Offense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Defense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Penalty Team</AttributeID>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Timeout Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                        <Dimension>
                            <ID>Team 1 3</ID>
                            <Name>Timeout Team</Name>
                            <DimensionID>Team</DimensionID>
                            <Attributes>
                                <Attribute>
                                    <AttributeID>Team Key</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Team Alias</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Offense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Defense Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Penalty Team</AttributeID>
                                    <AttributeHierarchyVisible>false</AttributeHierarchyVisible>
                                </Attribute>
                                <Attribute>
                                    <AttributeID>Timeout Team</AttributeID>
                                </Attribute>
                            </Attributes>
                        </Dimension>
                    </Dimensions>
                    <MeasureGroups>
                        <MeasureGroup>
                            <ID>Plays</ID>
                            <Name>Plays</Name>
                            <Measures>
                                <Measure>
                                    <ID>Score</ID>
                                    <Name>Score</Name>
                                    <DataType>Double</DataType>
                                    <Source>
                                        <NullProcessing>ZeroOrBlank</NullProcessing>
                                        <DataType>Double</DataType>
                                        <Source xsi:type="ColumnBinding">
                                            <TableID>ssasfact_Plays</TableID>
                                            <ColumnID>Score</ColumnID>
                                        </Source>
                                    </Source>
                                </Measure>
                                <Measure>
                                    <ID>Yards</ID>
                                    <Name>Yards</Name>
                                    <DataType>Double</DataType>
                                    <Source>
                                        <NullProcessing>Preserve</NullProcessing>
                                        <DataType>Double</DataType>
                                        <Source xsi:type="ColumnBinding">
                                            <TableID>ssasfact_Plays</TableID>
                                            <ColumnID>Yards</ColumnID>
                                        </Source>
                                    </Source>
                                </Measure>
                                <Measure>
                                    <ID>To Go</ID>
                                    <Name>To Go</Name>
                                    <DataType>Double</DataType>
                                    <Source>
                                        <NullProcessing>Preserve</NullProcessing>
                                        <DataType>Double</DataType>
                                        <Source xsi:type="ColumnBinding">
                                            <TableID>ssasfact_Plays</TableID>
                                            <ColumnID>ToGo</ColumnID>
                                        </Source>
                                    </Source>
                                </Measure>
                                <Measure>
                                    <ID>Penalty Yards</ID>
                                    <Name>Penalty Yards</Name>
                                    <DataType>Double</DataType>
                                    <Source>
                                        <NullProcessing>Preserve</NullProcessing>
                                        <DataType>Double</DataType>
                                        <Source xsi:type="ColumnBinding">
                                            <TableID>ssasfact_Plays</TableID>
                                            <ColumnID>Penalty_x0020_Yards</ColumnID>
                                        </Source>
                                    </Source>
                                </Measure>
                                <Measure>
                                    <ID>Plays Count</ID>
                                    <Name>Plays Count</Name>
                                    <AggregateFunction>Count</AggregateFunction>
                                    <DataType>Integer</DataType>
                                    <Source>
                                        <DataType>Integer</DataType>
                                        <DataSize>4</DataSize>
                                        <Source xsi:type="RowBinding">
                                            <TableID>ssasfact_Plays</TableID>
                                        </Source>
                                    </Source>
                                </Measure>
                            </Measures>
                            <StorageMode>Molap</StorageMode>
                            <ProcessingMode>Regular</ProcessingMode>
                            <Dimensions>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Date</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Date Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>Integer</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Play_x0020_Date_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Month Name</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>Integer</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Date</TableID>
                                                        <ColumnID>Z_x0020_Month_x0020_Name_x0020_Sort</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Year</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Date</TableID>
                                                        <ColumnID>Year</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Quarter</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Date</TableID>
                                                        <ColumnID>Quarter</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Season Description</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Date</TableID>
                                                        <ColumnID>Season_x0020_Description</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Field Position</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Field Position Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Field_x0020_Position_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Down</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>20</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Down</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Yard Line</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>20</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Yard_x0020_Line</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Rush Direction</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Rush_x0020_Direction</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Yard Line Fixed</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>20</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Yard_x0020_Line_x0020_Fixed</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Yard Line Direction</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Yard_x0020_Line_x0020_Direction</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Game</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Game Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>Integer</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Game_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Game Teams</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Game</TableID>
                                                        <ColumnID>Game_x0020_Teams</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Game Id</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Game</TableID>
                                                        <ColumnID>Game_x0020_Id</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Play Details</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Play Details Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Play_x0020_Details_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Rush</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Rush</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Pass</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Pass</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Incomplete</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Incomplete</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Touchdown</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Touchdown</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Sack</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Sack</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Challenge</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Challenge</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Challenge Reversed</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Challenge_x0020_Reversed</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Measurement</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Measurement</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Interception</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Interception</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Fumble</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Fumble</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Penalty</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Penalty</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Two Point Conversion</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Two_x0020_Point_x0020_Conversion</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Two Point Conversion Successful</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Two_x0020_Point_x0020_Conversion_x0020_Successful</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is Penalty Accepted</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_Penalty_x0020_Accepted</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Is No Play</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Details</TableID>
                                                        <ColumnID>Is_x0020_No_x0020_Play</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Play Time</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Play Time Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>Integer</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Play_x0020_Time_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Quarter</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                                        <ColumnID>Quarter</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Minute</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                                        <ColumnID>Minute</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Second</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                                        <ColumnID>Second</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Play Type</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Play Type Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Play_x0020_Type_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Formation</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Formation</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Play Type</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Play_x0020_Type</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Pass Type</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Pass_x0020_Type</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Penalty Type</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Penalty_x0020_Type</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Data Source</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Data Source Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>UnsignedTinyInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Data_x0020_Source_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Data Source Name</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>50</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Data_x0020_Source</TableID>
                                                        <ColumnID>Data_x0020_Source_x0020_Name</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="ManyToManyMeasureGroupDimension">
                                    <CubeDimensionID>Team</CubeDimensionID>
                                    <MeasureGroupID>Bridge Teams- Plays</MeasureGroupID>
                                </Dimension>
                                <Dimension xsi:type="ManyToManyMeasureGroupDimension">
                                    <CubeDimensionID>Team Role</CubeDimensionID>
                                    <MeasureGroupID>Bridge Teams- Plays</MeasureGroupID>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Team 1</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Team Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Offense_x0020_Team_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Team Alias</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Team_x0020_Alias</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Offense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Offense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Defense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Defense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Penalty Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Penalty_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Timeout Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Timeout_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Team 1 1</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Team Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Defense_x0020_Team_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Team Alias</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Team_x0020_Alias</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Offense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Offense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Defense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Defense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Penalty Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Penalty_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Timeout Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Timeout_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Team 1 2</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Team Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Penalty_x0020_Team_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Team Alias</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Team_x0020_Alias</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Offense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Offense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Defense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Defense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Penalty Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Penalty_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Timeout Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Timeout_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Team 1 3</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Team Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Plays</TableID>
                                                        <ColumnID>Timeout_x0020_Team_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Team Alias</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Team_x0020_Alias</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Offense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Offense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Defense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Defense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Penalty Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Penalty_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Timeout Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Timeout_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                            </Dimensions>
                            <Partitions>
                                <Partition>
                                    <ID>Plays Partition</ID>
                                    <Name>Plays Partition</Name>
                                    <Source xsi:type="TableBinding">
                                        <DataSourceID>Data Mart NFL</DataSourceID>
                                        <DbSchemaName>ssasfact</DbSchemaName>
                                        <DbTableName>Plays</DbTableName>
                                    </Source>
                                    <StorageMode>Molap</StorageMode>
                                    <ProcessingMode>Regular</ProcessingMode>
                                    <ProactiveCaching>
                                        <SilenceInterval>-PT1S</SilenceInterval>
                                        <Latency>-PT1S</Latency>
                                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                                    </ProactiveCaching>
                                </Partition>
                            </Partitions>
                            <ProactiveCaching>
                                <SilenceInterval>-PT1S</SilenceInterval>
                                <Latency>-PT1S</Latency>
                                <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                                <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                                <Source xsi:type="ProactiveCachingInheritedBinding" />
                            </ProactiveCaching>
                        </MeasureGroup>
                        <MeasureGroup>
                            <ID>Bridge Teams- Plays</ID>
                            <Name>Bridge Teams- Plays</Name>
                            <Measures>
                                <Measure>
                                    <ID>Bridge Teams- Plays Count</ID>
                                    <Name>Bridge Teams- Plays Count</Name>
                                    <AggregateFunction>Count</AggregateFunction>
                                    <DataType>Integer</DataType>
                                    <Source>
                                        <DataType>Integer</DataType>
                                        <DataSize>4</DataSize>
                                        <Source xsi:type="RowBinding">
                                            <TableID>ssasfact_Bridge_x0020_Teams-Plays</TableID>
                                        </Source>
                                    </Source>
                                    <Visible>false</Visible>
                                </Measure>
                            </Measures>
                            <StorageMode>Molap</StorageMode>
                            <ProcessingMode>Regular</ProcessingMode>
                            <Dimensions>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Field Position</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Field Position Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Bridge_x0020_Teams-Plays</TableID>
                                                        <ColumnID>Field_x0020_Position_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Down</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>20</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Down</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Yard Line</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>20</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Yard_x0020_Line</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Rush Direction</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Rush_x0020_Direction</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Yard Line Fixed</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>20</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Yard_x0020_Line_x0020_Fixed</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Yard Line Direction</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Field_x0020_Position</TableID>
                                                        <ColumnID>Yard_x0020_Line_x0020_Direction</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Game</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Game Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>Integer</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Bridge_x0020_Teams-Plays</TableID>
                                                        <ColumnID>Game_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Game Teams</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Game</TableID>
                                                        <ColumnID>Game_x0020_Teams</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Game Id</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Game</TableID>
                                                        <ColumnID>Game_x0020_Id</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Play Time</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Play Time Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>Integer</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Bridge_x0020_Teams-Plays</TableID>
                                                        <ColumnID>Play_x0020_Time_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Quarter</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                                        <ColumnID>Quarter</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Minute</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                                        <ColumnID>Minute</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Second</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>10</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Time</TableID>
                                                        <ColumnID>Second</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Play Type</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Play Type Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Bridge_x0020_Teams-Plays</TableID>
                                                        <ColumnID>Play_x0020_Type_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Formation</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Formation</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Play Type</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Play_x0020_Type</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Pass Type</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Pass_x0020_Type</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Penalty Type</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>200</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Play_x0020_Type</TableID>
                                                        <ColumnID>Penalty_x0020_Type</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Team</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Team Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>SmallInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Bridge_x0020_Teams-Plays</TableID>
                                                        <ColumnID>Team_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Team Alias</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Team_x0020_Alias</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Offense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Offense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Defense Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Defense_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Penalty Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Penalty_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Timeout Team</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>250</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team</TableID>
                                                        <ColumnID>Timeout_x0020_Team</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                                <Dimension xsi:type="RegularMeasureGroupDimension">
                                    <CubeDimensionID>Team Role</CubeDimensionID>
                                    <Attributes>
                                        <Attribute>
                                            <AttributeID>Team Role Key</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>UnsignedTinyInt</DataType>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasfact_Bridge_x0020_Teams-Plays</TableID>
                                                        <ColumnID>Team_x0020_Role_x0020_Key</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                            <Type>Granularity</Type>
                                        </Attribute>
                                        <Attribute>
                                            <AttributeID>Team Role</AttributeID>
                                            <KeyColumns>
                                                <KeyColumn>
                                                    <DataType>WChar</DataType>
                                                    <DataSize>50</DataSize>
                                                    <Source xsi:type="ColumnBinding">
                                                        <TableID>ssasdim_Team_x0020_Role</TableID>
                                                        <ColumnID>Team_x0020_Role</ColumnID>
                                                    </Source>
                                                </KeyColumn>
                                            </KeyColumns>
                                        </Attribute>
                                    </Attributes>
                                </Dimension>
                            </Dimensions>
                            <Partitions>
                                <Partition>
                                    <ID>Bridge Teams- Plays Partition</ID>
                                    <Name>Bridge Teams- Plays Partition</Name>
                                    <Source xsi:type="TableBinding">
                                        <DataSourceID>Data Mart NFL</DataSourceID>
                                        <DbSchemaName>ssasfact</DbSchemaName>
                                        <DbTableName>Bridge Teams-Plays</DbTableName>
                                    </Source>
                                    <StorageMode>Molap</StorageMode>
                                    <ProcessingMode>Regular</ProcessingMode>
                                    <ProactiveCaching>
                                        <SilenceInterval>-PT1S</SilenceInterval>
                                        <Latency>-PT1S</Latency>
                                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                                    </ProactiveCaching>
                                </Partition>
                            </Partitions>
                            <ProactiveCaching>
                                <SilenceInterval>-PT1S</SilenceInterval>
                                <Latency>-PT1S</Latency>
                                <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                                <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                                <Source xsi:type="ProactiveCachingInheritedBinding" />
                            </ProactiveCaching>
                        </MeasureGroup>
                    </MeasureGroups>
                    <Source>
                        <DataSourceViewID>Data Mart NFL</DataSourceViewID>
                    </Source>
                    <ProactiveCaching>
                        <SilenceInterval>-PT1S</SilenceInterval>
                        <Latency>-PT1S</Latency>
                        <SilenceOverrideInterval>-PT1S</SilenceOverrideInterval>
                        <ForceRebuildInterval>-PT1S</ForceRebuildInterval>
                        <Source xsi:type="ProactiveCachingInheritedBinding" />
                    </ProactiveCaching>
                </Cube>
            </Cubes>
            <DataSources>
                <DataSource xsi:type="RelationalDataSource">
                    <ID>Data Mart NFL</ID>
                    <Name>Data Mart NFL</Name>
                    <ConnectionString>Provider=SQLNCLI10.1;Data Source=LAPTOP;Integrated Security=SSPI;Initial Catalog=Data Mart NFL</ConnectionString>
                    <ImpersonationInfo>
                        <ImpersonationMode>Default</ImpersonationMode>
                    </ImpersonationInfo>
                    <Timeout>PT0S</Timeout>
                </DataSource>
            </DataSources>
            <DataSourceViews>
                <DataSourceView>
                    <ID>Data Mart NFL</ID>
                    <Name>Data Mart NFL</Name>
                    <Annotations>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:ShowFriendlyNames</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:CurrentLayout</Name>
                            <Value>_ALL_TABLES_</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:NameMatchingCriteria</Name>
                            <Value>1</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:SchemaRestriction</Name>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:RetrieveRelationships</Name>
                            <Value>true</Value>
                        </Annotation>
                        <Annotation>
                            <Name>http://schemas.microsoft.com/DataWarehouse/Designer/1.0:Layouts</Name>
                            <Value>
                                <Layouts xmlns="">
                                    <Diagram>
                                        <Name>_ALL_TABLES_</Name>
                                        <DiagramLayout>
                                            <dds>
                                                <diagram fontclsid="{0BE35203-8F91-11CE-9DE3-00AA004BB851}" mouseiconclsid="{0BE35204-8F91-11CE-9DE3-00AA004BB851}" defaultlayout="MSDDS.Rectilinear" defaultlineroute="MSDDS.Rectilinear" version="7" nextobject="12" scale="100" pagebreakanchorx="0" pagebreakanchory="0" pagebreaksizex="0" pagebreaksizey="0" scrollleft="23309" scrolltop="-5000" gridx="150" gridy="150" marginx="5000" marginy="5000" zoom="75" x="15748" y="13483" backcolor="15334399" defaultpersistence="2" PrintPageNumbersMode="3" PrintMarginTop="0" PrintMarginBottom="635" PrintMarginLeft="0" PrintMarginRight="0" marqueeselectionmode="0" mousepointer="0" snaptogrid="0" autotypeannotation="1" showscrollbars="1" viewpagebreaks="0" donotforceconnectorsbehindshapes="1" backpictureclsid="{00000000-0000-0000-0000-000000000000}">
                                                    <font>
                                                        <ddsxmlobjectstreamwrapper binary="010000009001b0300100065461686f6d61" />
                                                    </font>
                                                    <mouseicon>
                                                        <ddsxmlobjectstreamwrapper binary="6c74000000000000" />
                                                    </mouseicon>
                                                </diagram>
                                                <layoutmanager>
                                                    <ddsxmlobj />
                                                </layoutmanager>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Team Role" left="67030" top="0" logicalid="1" controlid="1" masterid="0" hint1="0" hint2="0" width="3133" height="1588" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="000800003d0c000034060000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Team Role" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Type" left="61024" top="0" logicalid="2" controlid="2" masterid="0" hint1="0" hint2="0" width="3006" height="2667" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000be0b00006b0a0000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Play Type" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Time" left="41044" top="0" logicalid="3" controlid="3" masterid="0" hint1="0" hint2="0" width="3000" height="2307" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000b80b000003090000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Play Time" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Data Source" left="47044" top="0" logicalid="4" controlid="4" masterid="0" hint1="0" hint2="0" width="4149" height="2667" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000351000006b0a0000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Data Source" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Team" left="54193" top="0" logicalid="5" controlid="5" masterid="0" hint1="0" hint2="0" width="3831" height="3747" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000f70e0000a30e0000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Team" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Game" left="35044" top="0" logicalid="6" controlid="6" masterid="0" hint1="0" hint2="0" width="3000" height="1947" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000b80b00009b070000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Game" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Date" left="28361" top="0" logicalid="7" controlid="7" masterid="0" hint1="0" hint2="0" width="3683" height="4466" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000630e000072110000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Date" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Play Details" left="19561" top="0" logicalid="8" controlid="8" masterid="0" hint1="0" hint2="0" width="5800" height="5000" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000a816000088130000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Play Details" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Field Position" left="12920" top="0" logicalid="9" controlid="9" masterid="0" hint1="0" hint2="0" width="3641" height="3027" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="00080000390e0000d30b0000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasdim_Field Position" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Bridge Teams-Plays" left="6470" top="0" logicalid="10" controlid="10" masterid="0" hint1="0" hint2="0" width="3450" height="3387" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="000800007a0d00003b0d0000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasfact_Bridge Teams-Plays" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                                <ddscontrol controlprogid="DdsShapes.DdsObjectManagedBridge.2" tooltip="Plays" left="20" top="0" logicalid="11" controlid="11" masterid="0" hint1="0" hint2="0" width="3450" height="4826" noresize="0" nomove="0" nodefaultattachpoints="0" autodrag="1" usedefaultiddshape="1" selectable="1" showselectionhandles="1" allownudging="1" isannotation="0" dontautolayout="0" groupcollapsed="0" tabstop="1" visible="1" snaptogrid="0">
                                                    <control>
                                                        <ddsxmlobjectstreaminitwrapper binary="000800007a0d0000da120000" />
                                                    </control>
                                                    <layoutobject>
                                                        <ddsxmlobj>
                                                            <property name="LogicalObject" value="ssasfact_Plays" vartype="8" />
                                                        </ddsxmlobj>
                                                    </layoutobject>
                                                    <shape groupshapeid="0" groupnode="0" />
                                                </ddscontrol>
                                            </dds>
                                        </DiagramLayout>
                                        <ShowRelationshipNames>False</ShowRelationshipNames>
                                        <UseDiagramDefaultLayout>True</UseDiagramDefaultLayout>
                                        <DiagramViewPortLeft>23309</DiagramViewPortLeft>
                                        <DiagramViewPortTop>-5000</DiagramViewPortTop>
                                        <DiagramBoundingLeft>0</DiagramBoundingLeft>
                                        <DiagramBoundingTop>0</DiagramBoundingTop>
                                        <DiagramZoom>75</DiagramZoom>
                                    </Diagram>
                                </Layouts>
                            </Value>
                        </Annotation>
                    </Annotations>
                    <DataSourceID>Data Mart NFL</DataSourceID>
                    <Schema>
                        <xs:schema id="Data_x0020_Mart_x0020_NFL" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" xmlns:msprop="urn:schemas-microsoft-com:xml-msprop">
                            <xs:element name="Data_x0020_Mart_x0020_NFL" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
                                <xs:complexType>
                                    <xs:choice minOccurs="0" maxOccurs="unbounded">
                                        <xs:element name="ssasdim_Team_x0020_Role" msprop:FriendlyName="Team Role" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Team Role" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Team_x0020_Role_x0020_Key" msprop:FriendlyName="Team Role Key" msprop:DbColumnName="Team Role Key" type="xs:unsignedByte" />
                                                    <xs:element name="Team_x0020_Role" msprop:FriendlyName="Team Role" msprop:DbColumnName="Team Role">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="50" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Play_x0020_Type" msprop:FriendlyName="Play Type" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Play Type" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Play_x0020_Type_x0020_Key" msprop:FriendlyName="Play Type Key" msprop:DbColumnName="Play Type Key" type="xs:short" />
                                                    <xs:element name="Formation" msprop:FriendlyName="Formation" msprop:DbColumnName="Formation">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Play_x0020_Type" msprop:FriendlyName="Play Type" msprop:DbColumnName="Play Type">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Pass_x0020_Type" msprop:FriendlyName="Pass Type" msprop:DbColumnName="Pass Type">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Penalty_x0020_Type" msprop:FriendlyName="Penalty Type" msprop:DbColumnName="Penalty Type">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Play_x0020_Time" msprop:FriendlyName="Play Time" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Play Time" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Play_x0020_Time_x0020_Key" msprop:FriendlyName="Play Time Key" msprop:DbColumnName="Play Time Key" type="xs:int" />
                                                    <xs:element name="Quarter" msprop:FriendlyName="Quarter" msprop:DbColumnName="Quarter">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Minute" msprop:FriendlyName="Minute" msprop:DbColumnName="Minute">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Second" msprop:FriendlyName="Second" msprop:DbColumnName="Second">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Data_x0020_Source" msprop:FriendlyName="Data Source" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Data Source" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Data_x0020_Source_x0020_Key" msprop:FriendlyName="Data Source Key" msprop:DbColumnName="Data Source Key" type="xs:unsignedByte" />
                                                    <xs:element name="Data_x0020_Source_x0020_Internal_x0020_Id" msprop:FriendlyName="Data Source Internal Id" msprop:DbColumnName="Data Source Internal Id">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="50" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Data_x0020_Source_x0020_Name" msprop:FriendlyName="Data Source Name" msprop:DbColumnName="Data Source Name">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="50" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Primary_x0020_Record_x0020_Name" msprop:FriendlyName="Primary Record Name" msprop:DbColumnName="Primary Record Name">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="50" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Transaction_x0020_Name" msprop:FriendlyName="Transaction Name" msprop:DbColumnName="Transaction Name">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="50" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Team" msprop:FriendlyName="Team" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Team" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Team_x0020_Key" msprop:FriendlyName="Team Key" msprop:DbColumnName="Team Key" type="xs:short" />
                                                    <xs:element name="Team_x0020_Original_x0020_Name" msprop:FriendlyName="Team Original Name" msprop:DbColumnName="Team Original Name">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Team_x0020_Name" msprop:FriendlyName="Team Name" msprop:DbColumnName="Team Name" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Team_x0020_Alias" msprop:FriendlyName="Team Alias" msprop:DbColumnName="Team Alias" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Team_x0020_City" msprop:FriendlyName="Team City" msprop:DbColumnName="Team City" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Team_x0020_Conference" msprop:FriendlyName="Team Conference" msprop:DbColumnName="Team Conference" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="220" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Sport_x0020_Abbrev" msprop:FriendlyName="Sport Abbrev" msprop:DbColumnName="Sport Abbrev" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="220" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Hist_x0020_Team_x0020_Name" msprop:FriendlyName="Hist Team Name" msprop:DbColumnName="Hist Team Name" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Offense_x0020_Team" msprop:DbColumnName="Offense Team" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Defense_x0020_Team" msprop:DbColumnName="Defense Team" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Penalty_x0020_Team" msprop:DbColumnName="Penalty Team" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Timeout_x0020_Team" msprop:DbColumnName="Timeout Team" minOccurs="0">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="250" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Game" msprop:FriendlyName="Game" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Game" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Game_x0020_Key" msprop:FriendlyName="Game Key" msprop:DbColumnName="Game Key" type="xs:int" />
                                                    <xs:element name="Game_x0020_Id" msprop:FriendlyName="Game Id" msprop:DbColumnName="Game Id">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Game_x0020_Teams" msprop:FriendlyName="Game Teams" msprop:DbColumnName="Game Teams">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Date" msprop:FriendlyName="Date" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Date" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Date_x0020_Key" msprop:FriendlyName="Date Key" msprop:DbColumnName="Date Key" type="xs:int" />
                                                    <xs:element name="Date" msprop:FriendlyName="Date" msprop:DbColumnName="Date" type="xs:dateTime" />
                                                    <xs:element name="Date_x0020_Desc" msprop:FriendlyName="Date Desc" msprop:DbColumnName="Date Desc">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="25" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Month_x0020_Name" msprop:FriendlyName="Month Name" msprop:DbColumnName="Month Name">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="9" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Year" msprop:FriendlyName="Year" msprop:DbColumnName="Year" type="xs:short" />
                                                    <xs:element name="Quarter" msprop:FriendlyName="Quarter" msprop:DbColumnName="Quarter" type="xs:short" />
                                                    <xs:element name="Quarter_x0020_Desc" msprop:FriendlyName="Quarter Desc" msprop:DbColumnName="Quarter Desc">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="8" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Z_x0020_Month_x0020_Name_x0020_Sort" msdata:ReadOnly="true" msprop:FriendlyName="Z Month Name Sort" msprop:DbColumnName="Z Month Name Sort" type="xs:int" minOccurs="0" />
                                                    <xs:element name="Season_x0020_Year" msprop:FriendlyName="Season Year" msprop:DbColumnName="Season Year" type="xs:int" />
                                                    <xs:element name="Season_x0020_Description" msprop:FriendlyName="Season Description" msprop:DbColumnName="Season Description">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Play_x0020_Details" msprop:FriendlyName="Play Details" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Play Details" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Play_x0020_Details_x0020_Key" msprop:FriendlyName="Play Details Key" msprop:DbColumnName="Play Details Key" type="xs:short" />
                                                    <xs:element name="Is_x0020_Rush" msprop:FriendlyName="Is Rush" msprop:DbColumnName="Is Rush">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Pass" msprop:FriendlyName="Is Pass" msprop:DbColumnName="Is Pass">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Incomplete" msprop:FriendlyName="Is Incomplete" msprop:DbColumnName="Is Incomplete">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Touchdown" msprop:FriendlyName="Is Touchdown" msprop:DbColumnName="Is Touchdown">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Sack" msprop:FriendlyName="Is Sack" msprop:DbColumnName="Is Sack">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Challenge" msprop:FriendlyName="Is Challenge" msprop:DbColumnName="Is Challenge">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Challenge_x0020_Reversed" msprop:FriendlyName="Is Challenge Reversed" msprop:DbColumnName="Is Challenge Reversed">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Measurement" msprop:FriendlyName="Is Measurement" msprop:DbColumnName="Is Measurement">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Interception" msprop:FriendlyName="Is Interception" msprop:DbColumnName="Is Interception">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Fumble" msprop:FriendlyName="Is Fumble" msprop:DbColumnName="Is Fumble">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Penalty" msprop:FriendlyName="Is Penalty" msprop:DbColumnName="Is Penalty">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Two_x0020_Point_x0020_Conversion" msprop:FriendlyName="Is Two Point Conversion" msprop:DbColumnName="Is Two Point Conversion">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Two_x0020_Point_x0020_Conversion_x0020_Successful" msprop:FriendlyName="Is Two Point Conversion Successful" msprop:DbColumnName="Is Two Point Conversion Successful">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_Penalty_x0020_Accepted" msprop:FriendlyName="Is Penalty Accepted" msprop:DbColumnName="Is Penalty Accepted">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Is_x0020_No_x0020_Play" msprop:FriendlyName="Is No Play" msprop:DbColumnName="Is No Play">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="10" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasdim_Field_x0020_Position" msprop:FriendlyName="Field Position" msprop:DbSchemaName="ssasdim" msprop:DbTableName="Field Position" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Field_x0020_Position_x0020_Key" msprop:FriendlyName="Field Position Key" msprop:DbColumnName="Field Position Key" type="xs:short" />
                                                    <xs:element name="Down" msprop:FriendlyName="Down" msprop:DbColumnName="Down">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="20" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Yard_x0020_Line" msprop:FriendlyName="Yard Line" msprop:DbColumnName="Yard Line">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="20" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Rush_x0020_Direction" msprop:FriendlyName="Rush Direction" msprop:DbColumnName="Rush Direction">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Yard_x0020_Line_x0020_Fixed" msprop:FriendlyName="Yard Line Fixed" msprop:DbColumnName="Yard Line Fixed">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="20" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                    <xs:element name="Yard_x0020_Line_x0020_Direction" msprop:FriendlyName="Yard Line Direction" msprop:DbColumnName="Yard Line Direction">
                                                        <xs:simpleType>
                                                            <xs:restriction base="xs:string">
                                                                <xs:maxLength value="200" />
                                                            </xs:restriction>
                                                        </xs:simpleType>
                                                    </xs:element>
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasfact_Bridge_x0020_Teams-Plays" msprop:FriendlyName="Bridge Teams-Plays" msprop:DbSchemaName="ssasfact" msprop:DbTableName="Bridge Teams-Plays" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Data_x0020_Source_x0020_Key" msprop:FriendlyName="Data Source Key" msprop:DbColumnName="Data Source Key" type="xs:unsignedByte" />
                                                    <xs:element name="Team_x0020_Key" msprop:FriendlyName="Team Key" msprop:DbColumnName="Team Key" type="xs:short" />
                                                    <xs:element name="Team_x0020_Role_x0020_Key" msprop:FriendlyName="Team Role Key" msprop:DbColumnName="Team Role Key" type="xs:unsignedByte" />
                                                    <xs:element name="Game_x0020_Key" msprop:FriendlyName="Game Key" msprop:DbColumnName="Game Key" type="xs:int" />
                                                    <xs:element name="Play_x0020_Type_x0020_Key" msprop:FriendlyName="Play Type Key" msprop:DbColumnName="Play Type Key" type="xs:short" />
                                                    <xs:element name="Field_x0020_Position_x0020_Key" msprop:FriendlyName="Field Position Key" msprop:DbColumnName="Field Position Key" type="xs:short" />
                                                    <xs:element name="Play_x0020_Time_x0020_Key" msprop:FriendlyName="Play Time Key" msprop:DbColumnName="Play Time Key" type="xs:int" />
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                        <xs:element name="ssasfact_Plays" msprop:FriendlyName="Plays" msprop:DbSchemaName="ssasfact" msprop:DbTableName="Plays" msprop:TableType="View">
                                            <xs:complexType>
                                                <xs:sequence>
                                                    <xs:element name="Play_x0020_Date_x0020_Key" msprop:FriendlyName="Play Date Key" msprop:DbColumnName="Play Date Key" type="xs:int" />
                                                    <xs:element name="Data_x0020_Source_x0020_Key" msprop:FriendlyName="Data Source Key" msprop:DbColumnName="Data Source Key" type="xs:unsignedByte" />
                                                    <xs:element name="Game_x0020_Key" msprop:FriendlyName="Game Key" msprop:DbColumnName="Game Key" type="xs:int" />
                                                    <xs:element name="Play_x0020_Type_x0020_Key" msprop:FriendlyName="Play Type Key" msprop:DbColumnName="Play Type Key" type="xs:short" />
                                                    <xs:element name="Field_x0020_Position_x0020_Key" msprop:FriendlyName="Field Position Key" msprop:DbColumnName="Field Position Key" type="xs:short" />
                                                    <xs:element name="Play_x0020_Time_x0020_Key" msprop:FriendlyName="Play Time Key" msprop:DbColumnName="Play Time Key" type="xs:int" />
                                                    <xs:element name="Play_x0020_Details_x0020_Key" msprop:FriendlyName="Play Details Key" msprop:DbColumnName="Play Details Key" type="xs:short" />
                                                    <xs:element name="Score" msprop:FriendlyName="Score" msprop:DbColumnName="Score" type="xs:double" minOccurs="0" />
                                                    <xs:element name="Yards" msprop:FriendlyName="Yards" msprop:DbColumnName="Yards" type="xs:double" minOccurs="0" />
                                                    <xs:element name="ToGo" msprop:FriendlyName="ToGo" msprop:DbColumnName="ToGo" type="xs:double" minOccurs="0" />
                                                    <xs:element name="Penalty_x0020_Yards" msprop:FriendlyName="Penalty Yards" msprop:DbColumnName="Penalty Yards" type="xs:double" minOccurs="0" />
                                                    <xs:element name="Offense_x0020_Team_x0020_Key" msprop:DbColumnName="Offense Team Key" type="xs:short" minOccurs="0" />
                                                    <xs:element name="Defense_x0020_Team_x0020_Key" msprop:DbColumnName="Defense Team Key" type="xs:short" minOccurs="0" />
                                                    <xs:element name="Penalty_x0020_Team_x0020_Key" msprop:DbColumnName="Penalty Team Key" type="xs:short" minOccurs="0" />
                                                    <xs:element name="Timeout_x0020_Team_x0020_Key" msprop:DbColumnName="Timeout Team Key" type="xs:short" minOccurs="0" />
                                                </xs:sequence>
                                            </xs:complexType>
                                        </xs:element>
                                    </xs:choice>
                                </xs:complexType>
                                <xs:unique name="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Team_x0020_Role" />
                                    <xs:field xpath="Team_x0020_Role_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Play_x0020_Type_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Play_x0020_Type" />
                                    <xs:field xpath="Play_x0020_Type_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Play_x0020_Time_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Play_x0020_Time" />
                                    <xs:field xpath="Play_x0020_Time_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Data_x0020_Source_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Data_x0020_Source" />
                                    <xs:field xpath="Data_x0020_Source_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Team_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Team" />
                                    <xs:field xpath="Team_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Game_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Game" />
                                    <xs:field xpath="Game_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Date_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Date" />
                                    <xs:field xpath="Date_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Play_x0020_Details_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Play_x0020_Details" />
                                    <xs:field xpath="Play_x0020_Details_x0020_Key" />
                                </xs:unique>
                                <xs:unique name="ssasdim_Field_x0020_Position_Constraint1" msdata:ConstraintName="Constraint1" msdata:PrimaryKey="true">
                                    <xs:selector xpath=".//ssasdim_Field_x0020_Position" />
                                    <xs:field xpath="Field_x0020_Position_x0020_Key" />
                                </xs:unique>
                            </xs:element>
                        </xs:schema>
                        <diffgr:diffgram xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" xmlns:diffgr="urn:schemas-microsoft-com:xml-diffgram-v1" />
                    </Schema>
                </DataSourceView>
            </DataSourceViews>
        </Database>
    </ObjectDefinition>
</Create>'
END
GO


IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[ssasload].[Get SSAS BASE DB Create Script - NFL]'))
BEGIN
PRINT 'CREATED FUNCTION [ssasload].[Get SSAS BASE DB Create Script - NFL]'
END
GO